## The Basics

Thanks for making a pull request! Before making a pull request, we have some
things for you to read through first:

- We generally do not accept patches for formatting fixes, unless the formatting
  fixes are part of a functional patch (for example, when fixing a bug in a
  function you can fix up the lines surrounding it if needed).
- Patches that break compatibility with the original game data or save data will
  not be accepted.
- New features and user interface changes will most likely not be accepted
  unless they are for improving user accessibility.
- New platforms are acceptable if they use SDL + PhysicsFS and don't mess with
  the game source too much.
    - (No homebrew console targets, sorry! Maybe do the work in SDL instead?)
- Pull requests that do not fill out the Legal Stuff will be closed
  automatically.

If you understand these notes, you can delete the text in this section. Pull
requests that still have this text will be closed automatically.


## Changes:

Describe your patch here!


## Legal Stuff:

By submitting this pull request, I confirm that...

- [ ] My changes may be used in a future commercial release of VVVVVV
- [ ] I will be credited in a `CONTRIBUTORS` file and the "GitHub Friends"
  section of the credits for all of said releases, but will NOT be compensated
  for these changes
